'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactUikitBase = require('react-uikit-base');

var _ufunc = require('ufunc');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Alert = function (_React$Component) {
  _inherits(Alert, _React$Component);

  function Alert(props) {
    _classCallCheck(this, Alert);

    var _this = _possibleConstructorReturn(this, (Alert.__proto__ || Object.getPrototypeOf(Alert)).call(this, props));

    _this.handleClose = _this.handleClose.bind(_this);
    return _this;
  }

  _createClass(Alert, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var element = _reactUikitBase.helpers.getElement(this.props.kitid);

      element.style.display = this.props.show ? 'block' : 'none';
    }
  }, {
    key: 'handleClose',
    value: function handleClose(e) {
      e.preventDefault();
      this.props.close(e, this.props.kitid);
    }
  }, {
    key: 'render',
    value: function render() {
      var props = this.props;

      // CSS classes
      var context = {
        success: 'uk-alert-success',
        warning: 'uk-alert-warning',
        danger: 'uk-alert-danger'
      };

      var cssClassNames = _reactUikitBase.helpers.cleanClasses(['uk-alert', props.classes, context[props.context] || null, props.large ? ' uk-alert-large' : null, props.className]);

      // Remove non valid html attributes
      var ignoreProps = ['children', 'classes', 'close', 'context', 'kitid', 'large', 'show'];

      var cleanProps = _reactUikitBase.helpers.cleanProps(ignoreProps)(props);

      // Elements
      var close = (0, _ufunc.maybeIf)(_react2.default.createElement('a', {
        href: '#',
        className: 'uk-alert-close uk-close',
        'data-kitid': props.kitid,
        onClick: this.handleClose
      }))(props.close);

      // Return Component
      return _react2.default.createElement(
        'div',
        _extends({}, cleanProps, (0, _reactUikitBase.events)(props), {
          'data-kitid': props.kitid,
          className: cssClassNames
        }),
        close,
        props.children
      );
    }
  }]);

  return Alert;
}(_react2.default.Component);

Alert.propTypes = {
  children: _react2.default.PropTypes.any,
  className: _react2.default.PropTypes.string,
  classes: _react2.default.PropTypes.array,
  close: _react2.default.PropTypes.func,
  context: _react2.default.PropTypes.oneOf(['success', 'warning', 'danger']),
  kitid: _react2.default.PropTypes.string,
  large: _react2.default.PropTypes.bool,
  show: _react2.default.PropTypes.bool
};

exports.default = (0, _reactUikitBase.base)(Alert);